open Yices
open Format
open Rules
open Config
open Orders

let ltob lb =
 match lb with
 | Yices.True -> true
 | Yices.False -> false
 | Yices.Undef -> false




let not_prev_trs ctx acc rls_yexpr = 
 match acc with 
   [] -> mk_true ctx
 | _ ->
  let not_or acc_i = mk_or ctx (Array.of_list 
      (List.map (fun (s,t) -> mk_not ctx (List.assoc (s,t) rls_yexpr)) acc_i)) 
  in 
   mk_and ctx (Array.of_list (List.map not_or acc)) 

(* variante 2: repeat so lange größe des trs nicht kleiner wird. danach 2 *)
let rec get cfg es fs n =
 (if cfg.vm then eprintf "start MAXSN@.");
 let rls = get_rules_of_es es in  
 let rec iterate acc i =
 (if cfg.vm then printf "i = %d @." i);
  if i <= 1 then acc
  else
  let ctx = mk_context () in 
  let ty  = mk_type ctx "int" in
  let rls_yexpr = ref [] in
  
  (if (cfg.sn_mthd = LPO || cfg.sn_mthd = RPO) then
  let vars = [ f, mk_var_decl ctx f ty | f <- fs ] in
  let a = [ f, mk_var_from_decl ctx x | f,x <- vars ] in
  let bnd_0 = mk_num ctx 0 in
  let bnd_n = mk_num ctx (List.length fs) in
  let a_bnds = mk_and ctx (Array.of_list 
                  ([ mk_ge ctx x bnd_0 | f,x <- a ] 
                 @ [ mk_ge ctx bnd_n x | f,x <- a])) in
  assert_simple ctx a_bnds;

  (if cfg.sn_mthd = LPO then 
    rls_yexpr := [ (s,t),(ylpo ctx a s t) | s,t <- rls ]
  else if cfg.sn_mthd = RPO then
    rls_yexpr := [ (s,t),(yrpo ctx a s t) | s,t <- rls ] );
  else if (cfg.sn_mthd = KBO) then
   let fs = Listx.unique [ fa | l, r <- rls; fa <- Term.functions_arity l @ Term.functions_arity r ] in
 
  let vars = [ f, a , mk_var_decl ctx f ty, mk_var_decl ctx (f^"p") ty | f,a <- fs ] in
  let wfs_a = [ f, mk_var_from_decl ctx w, mk_var_from_decl ctx p, a | f,a,w,p <- vars ] in
  let wfs = [ w, p, f | f,w,p,a <- wfs_a ] in
  let wcs = [ w, p, f | f,w,p,a <- wfs_a; a = 0 ] in
  let w1s = [ w, p, f | f,w,p,a <- wfs_a; a = 1 ] in
  let var_w0 = (mk_var_decl ctx "w0" ty) in
  let w0 =  mk_var_from_decl ctx var_w0 in 
  let _ = assert_simple ctx (adm_smt ctx (wfs,wcs,w1s,w0)) in
   rls_yexpr := [ (s,t),(ykbo ctx (wfs,w0) s t) | s,t <- rls ];
  );
  let a_rls = [ (s,t), assert_weighted ctx y (Int64.of_int 1) |
                (s,t),y <- !rls_yexpr ] in
  let a_acc = not_prev_trs ctx acc !rls_yexpr in
  let _ = assert_simple ctx a_acc in
  (* let _ = dump_context ctx in *)
  let res =
  match max_sat ctx with
    True -> 
       let m = get_model ctx in
        [ lr |  (lr,a_st) <- a_rls ; get_assertion_value m a_st = 1 ]
  | False -> []
  | Undef -> []
  in
  let _ = del_context ctx in
  if res = [] then acc
  else 
   iterate (res::acc) (i-1)
in
 iterate [] n














