open Term
open Overlap
open Rewriting

let c_trs = <:rules<
b(d(x)) -> x;
e(c(x)) -> a(x);
c(e(x)) -> a(x);
b(e(x)) -> a(x);
c(a(x)) -> a(c(x));
e(a(x)) -> a(e(x));
c(d(a(x))) -> a(x);
b(a(x)) -> a(c(x));
d(a(a(x))) -> a(d(a(x)));
d(e(c(x))) -> e(x);
c(e(x)) -> e(c(x));
b(e(x)) -> e(c(x));
d(c(e(x))) -> e(x);
d(e(e(c(x)))) -> e(e(x));
c(c(e(x))) -> e(c(c(x)));
d(b(a(x))) -> a(x);
d(e(b(a(x)))) -> e(a(x));
d(b(e(x))) -> e(x);
d(b(b(e(x)))) -> b(e(x));
d(e(b(e(x)))) -> e(e(x));
d(c(c(a(x)))) -> c(a(x));
c(d(c(a(x)))) -> c(a(x));
b(c(a(x))) -> c(c(a(x)));
c(d(d(a(a(x))))) -> d(a(a(x)));
d(b(b(a(x)))) -> b(a(x));
c(d(b(a(x)))) -> b(a(x));
b(a(x)) -> c(a(x));
b(e(x)) -> c(e(x));
d(b(b(b(a(x))))) -> b(b(a(x)));
d(b(b(b(a(a(x)))))) -> b(b(a(a(x))));
d(c(c(c(a(x))))) -> c(c(a(x)));
b(c(c(a(x)))) -> c(c(c(a(x))));
c(d(d(c(a(a(x)))))) -> d(c(a(a(x))));
a(d(a(c(x)))) -> a(a(x));
a(a(d(a(c(x))))) -> a(a(a(x)));
a(d(a(c(c(x))))) -> a(a(c(x)));
b(b(a(d(a(x))))) -> a(b(a(x)));
d(a(a(a(c(x))))) -> a(a(a(x)));
e(x) -> d(a(x));
c(e(e(x))) -> e(e(c(x)));
e(b(a(x))) -> a(a(x));
e(e(x)) -> d(e(a(x)));
b(a(a(x))) -> a(b(a(x)));
b(b(a(x))) -> c(b(a(x)));
b(b(e(x))) -> c(b(e(x)));
b(e(e(x))) -> e(b(e(x)));
d(b(e(b(e(x))))) -> b(e(e(x)));
b(e(d(b(e(x))))) -> e(b(e(x)));
b(e(b(e(x)))) -> e(b(b(e(x))));
d(c(a(a(x)))) -> a(d(c(a(x))));
d(d(a(a(a(x))))) -> a(d(d(a(a(x)))));
d(a(b(a(x)))) -> a(d(b(a(x))));
b(c(e(x))) -> c(b(e(x)));
b(b(a(a(x)))) -> a(b(b(a(x))));
b(b(b(a(x)))) -> c(b(b(a(x))));
b(b(a(a(a(x))))) -> a(b(b(a(a(x)))));
b(b(b(a(a(x))))) -> c(b(b(a(a(x)))));
d(c(a(a(x)))) -> a(a(x));
d(d(c(a(a(a(x)))))) -> a(d(d(c(a(a(x))))));
a(d(c(a(x)))) -> a(a(x));
c(a(d(a(x)))) -> a(a(x));
c(a(d(c(a(x))))) -> c(a(a(x)));
b(a(d(a(x)))) -> a(a(x));
b(a(b(a(x)))) -> a(b(b(a(x))));
d(a(b(a(x)))) -> a(a(x));
d(a(a(b(a(x))))) -> a(a(a(x)));
d(a(a(c(x)))) -> a(a(x))
>>

let r_hat rls =
 [ l, nf rls r | l,r <- rls ]

let r_prime rls =
 let rls_hat = r_hat rls in
 [ l, r | l,r <- rls_hat; l = nf (Listset.remove (l,r) rls_hat) l ]

let test = 
<:rules<
 plus(x,0) -> x;
 plus(0,x) -> x;
 plus(x,s(y)) -> s(plus(x,y));
 plus(s(x),y) -> s(plus(x,y));
 plus(plus(x,y),z) -> plus(x,plus(y,z));
 f(h(s(y),g(f(x)))) -> f(h(s(s(y)),x));
 f(h(s(z),g(h(y,x)))) -> f(h(s(s(plus(z,y))),x))
>>

let test2 = <:rules<
 plus(x,0) -> x;
 plus(0,x) -> x;
 plus(x,s(y)) -> s(plus(x,y));
 plus(s(x),y) -> s(plus(x,y));
 plus(plus(x,y),z) -> plus(x,plus(y,z));
 f(g(f(x))) -> f(h(s(0),x));
 f(g(h(y,x))) -> f(h(s(y),x));
 f(h(z,h(y,x))) -> f(h(plus(z,y),x));
 f(h(s(y),g(f(x)))) -> f(h(s(s(y)),x));
 f(h(s(z),g(h(y,x)))) -> f(h(s(s(plus(z,y))),x))
>>

let ghe = <:rules<
 f(f(x,y),z) ->  f(x,f(y,z)) ;
 f(x,i(x)) -> e();
 f(x,e()) ->  x;
 f(h(x), h(y)) ->  h(f(x,y)) 
>>

let endo = <:rules<
f(f(x,y),z) -> f(x,f(y,z));
f(x,e()) -> x;
f(x,i(x)) -> e();
h(f(x,y)) -> f(h(x),h(y)) >>

let endo1 = <:rules<
f(f(x,y),z) -> f(x,f(y,z));
f(x,e()) -> x;
f(x,i(x)) -> e();
f(h(x),h(y)) -> h(f(x,y)) ;
f(h(x),f(h(y),z)) -> f(h(f(x,y)),z) 
>>


let endo2 = <:rules<
f(f(x,y),z) -> f(x,f(y,z));
f(x,e()) -> x;
f(x,i(x)) -> e();
f(h(x),h(y)) -> h(f(x,y)) ;
f(h(f(x,y)),z) -> f(h(x),f(h(y),z)) ;
f(h(h(f(x,y))),z) -> f(h(h(x)),f(h(h(y)),z));
f(h(h(x)),f(h(h(y)),i(h(h(f(x,y)))))) -> e()
>>



let endo_comp = <:rules<
f(x,i(x)) -> e();
f(x,e()) -> x;
f(e(),x) -> x;
f(i(x),x) -> e();
f(i(x),f(x,y)) -> y;
i(f(x,y)) -> f(i(y),i(x));
f(f(x,y),z) -> f(x,f(y,z));
f(y,f(i(y),x)) -> x;
i(e()) -> e();
i(i(x)) -> x;
h(f(x,y)) -> f(h(x),h(y))
>>


let step1_0 = <:rules<
s(p(x)) -> x;
p(s(x)) -> x;
s(x + y) -> s(x) + y
>>

let step1_1 = <:rules<
s(p(x)) -> x;
p(s(x)) -> x;
s(x) + y -> s(x + y)
>>

let step2_1 = <:rules<
s(p(x)) -> x;
p(s(x)) -> x;
p(plus(s(x),y)) -> plus(x,y);
s(plus(p(x),y)) -> plus(x,y);
plus(s(x),y) -> s(plus(x,y))
>>

let step2_1_prime = <:rules<
s(p(x)) -> x;
p(s(x)) -> x;
s(plus(p(x),y)) -> plus(x,y);
plus(s(x),y) -> s(plus(x,y))
>>


let step2_2 = <:rules<
s(p(x)) -> x;
p(s(x)) -> x;
p(plus(s(x),y)) -> plus(x,y);
s(plus(x,y)) -> plus(s(x),y) 
>>


let simple = <:rules<
 f(g(x)) -> x;
 f(x) -> g(g(x));
 g(g(g(x))) -> x
>>

let simple0 = <:rules<
 f(g(x)) -> x;
 f(x) -> g(g(x));
>>




let run_ex = <:rules<
s(p(x)) -> x;
p(s(x)) -> x;
s(x) + y -> s(x + y);
s(p(x) + y) -> x +y;
s((p(x)+ y)+z) -> (x+y)+z;
s((p(x) + y) + z) ->  (x + y) + z
>>

